package framework;

import java.io.File;
import java.io.FilenameFilter;

public class Filter {

	public static String[] getFiles(String d, String e) {
		ExtensionFilter filter = new ExtensionFilter(e);
		File dir = new File(d);

		String[] result = dir.list(filter); 
		return  result == null? new String[0]: result;
	}

	static class ExtensionFilter implements FilenameFilter {

		private String extension;

		public ExtensionFilter(String extension) {
			this.extension = extension;
		}

		public boolean accept(File dir, String name) {
			return (name.endsWith(extension));
		}
	}
}
