package aspects;

import java.util.Stack;

public abstract aspect TrustedStack {

	private Stack<Boolean> stack = new Stack<Boolean>();
	abstract pointcut untrustedCode();
	
	before() : untrustedCode() {
		System.out.println("setting threadlocal "+thisJoinPoint.getSignature());
		stack.push(true);
		cflow_untrusted.set(true);
	}
	
	after() : untrustedCode() {
		System.out.println("setting threadlocal");
		stack.pop();
		
		if(stack.isEmpty())
			cflow_untrusted.set(false);
		else
			cflow_untrusted.set(stack.peek());
	}
	
	public static InheritableThreadLocal<Boolean> cflow_untrusted = new InheritableThreadLocal<Boolean>(){
		@Override
		protected Boolean initialValue() {
			return false;
		}
	};
}
